Show / Hide Table of Contents

Interface ICfnFileSystemProps

Properties for defining a CfnFileSystem.

Namespace: Amazon.CDK.AWS.EFS
Assembly: Amazon.CDK.Lib.dll
Syntax (csharp)
public interface ICfnFileSystemProps
Syntax (vb)
Public Interface ICfnFileSystemProps
Remarks

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html

ExampleMetadata: fixture=_generated

Examples
// The code below shows an example of how to instantiate this type.
             // The values are placeholders you should change.
             using Amazon.CDK.AWS.EFS;

             var fileSystemPolicy;

             var cfnFileSystemProps = new CfnFileSystemProps {
                 AvailabilityZoneName = "availabilityZoneName",
                 BackupPolicy = new BackupPolicyProperty {
                     Status = "status"
                 },
                 BypassPolicyLockoutSafetyCheck = false,
                 Encrypted = false,
                 FileSystemPolicy = fileSystemPolicy,
                 FileSystemProtection = new FileSystemProtectionProperty {
                     ReplicationOverwriteProtection = "replicationOverwriteProtection"
                 },
                 FileSystemTags = new [] { new ElasticFileSystemTagProperty {
                     Key = "key",
                     Value = "value"
                 } },
                 KmsKeyId = "kmsKeyId",
                 LifecyclePolicies = new [] { new LifecyclePolicyProperty {
                     TransitionToArchive = "transitionToArchive",
                     TransitionToIa = "transitionToIa",
                     TransitionToPrimaryStorageClass = "transitionToPrimaryStorageClass"
                 } },
                 PerformanceMode = "performanceMode",
                 ProvisionedThroughputInMibps = 123,
                 ReplicationConfiguration = new ReplicationConfigurationProperty {
                     Destinations = new [] { new ReplicationDestinationProperty {
                         AvailabilityZoneName = "availabilityZoneName",
                         FileSystemId = "fileSystemId",
                         KmsKeyId = "kmsKeyId",
                         Region = "region",
                         RoleArn = "roleArn",
                         Status = "status",
                         StatusMessage = "statusMessage"
                     } }
                 },
                 ThroughputMode = "throughputMode"
             };

Synopsis

Properties

AvailabilityZoneName

For One Zone file systems, specify the AWS Availability Zone in which to create the file system.

BackupPolicy

Use the BackupPolicy to turn automatic backups on or off for the file system.

BypassPolicyLockoutSafetyCheck

(Optional) A boolean that specifies whether or not to bypass the FileSystemPolicy lockout safety check.

Encrypted

A Boolean value that, if true, creates an encrypted file system.

FileSystemPolicy

The FileSystemPolicy for the EFS file system.

FileSystemProtection

Describes the protection on the file system.

FileSystemTags

Use to create one or more tags associated with the file system.

KmsKeyId

The ID of the AWS KMS key to be used to protect the encrypted file system.

LifecyclePolicies

An array of LifecyclePolicy objects that define the file system's LifecycleConfiguration object.

PerformanceMode

The performance mode of the file system.

ProvisionedThroughputInMibps

The throughput, measured in mebibytes per second (MiBps), that you want to provision for a file system that you're creating.

ReplicationConfiguration

Describes the replication configuration for a specific file system.

ThroughputMode

Specifies the throughput mode for the file system.

Properties

AvailabilityZoneName

For One Zone file systems, specify the AWS Availability Zone in which to create the file system.

string? AvailabilityZoneName { get; }
Property Value

string

Remarks

Use the format us-east-1a to specify the Availability Zone. For more information about One Zone file systems, see EFS file system types in the Amazon EFS User Guide .

One Zone file systems are not available in all Availability Zones in AWS Regions where Amazon EFS is available.

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-availabilityzonename

BackupPolicy

Use the BackupPolicy to turn automatic backups on or off for the file system.

object? BackupPolicy { get; }
Property Value

object

Remarks

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-backuppolicy

Type union: either IResolvable or CfnFileSystem.IBackupPolicyProperty

BypassPolicyLockoutSafetyCheck

(Optional) A boolean that specifies whether or not to bypass the FileSystemPolicy lockout safety check.

object? BypassPolicyLockoutSafetyCheck { get; }
Property Value

object

Remarks

The lockout safety check determines whether the policy in the request will lock out, or prevent, the IAM principal that is making the request from making future PutFileSystemPolicy requests on this file system. Set BypassPolicyLockoutSafetyCheck to True only when you intend to prevent the IAM principal that is making the request from making subsequent PutFileSystemPolicy requests on this file system. The default value is False .

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-bypasspolicylockoutsafetycheck

Type union: either bool or IResolvable

Encrypted

A Boolean value that, if true, creates an encrypted file system.

object? Encrypted { get; }
Property Value

object

Remarks

When creating an encrypted file system, you have the option of specifying a KmsKeyId for an existing AWS KMS key . If you don't specify a KMS key , then the default KMS key for Amazon EFS , /aws/elasticfilesystem , is used to protect the encrypted file system.

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-encrypted

Type union: either bool or IResolvable

FileSystemPolicy

The FileSystemPolicy for the EFS file system.

object? FileSystemPolicy { get; }
Property Value

object

Remarks

A file system policy is an IAM resource policy used to control NFS access to an EFS file system. For more information, see Using IAM to control NFS access to Amazon EFS in the Amazon EFS User Guide .

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-filesystempolicy

FileSystemProtection

Describes the protection on the file system.

object? FileSystemProtection { get; }
Property Value

object

Remarks

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-filesystemprotection

Type union: either IResolvable or CfnFileSystem.IFileSystemProtectionProperty

FileSystemTags

Use to create one or more tags associated with the file system.

CfnFileSystem.IElasticFileSystemTagProperty[]? FileSystemTags { get; }
Property Value

IElasticFileSystemTagProperty[]

Remarks

Each tag is a user-defined key-value pair. Name your file system on creation by including a "Key":"Name","Value":"{value}" key-value pair. Each key must be unique. For more information, see Tagging AWS resources in the AWS General Reference Guide .

See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-filesystemtags

KmsKeyId

The ID of the AWS KMS key to be used to protect the encrypted file system.

object? KmsKeyId { get; }
Property Value

object

Remarks

This parameter is only required if you want to use a nondefault KMS key . If this parameter is not specified, the default KMS key for Amazon EFS is used. This ID can be in one of the following formats:

    If KmsKeyId is specified, the Encrypted parameter must be set to true.

    See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-kmskeyid

    Type union: either string or IKeyRef

    LifecyclePolicies

    An array of LifecyclePolicy objects that define the file system's LifecycleConfiguration object.

    object? LifecyclePolicies { get; }
    Property Value

    object

    Remarks

    A LifecycleConfiguration object informs Lifecycle management of the following:

      Amazon EFS requires that each <code>LifecyclePolicy</code> object have only a single transition. This means that in a request body, <code>LifecyclePolicies</code> needs to be structured as an array of <code>LifecyclePolicy</code> objects, one object for each transition, <code>TransitionToIA</code> , <code>TransitionToArchive</code> <code>TransitionToPrimaryStorageClass</code> . See the example requests in the following section for more information.
      

      See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-lifecyclepolicies

      Type union: either IResolvable or (either IResolvable or CfnFileSystem.ILifecyclePolicyProperty)[]

      PerformanceMode

      The performance mode of the file system.

      string? PerformanceMode { get; }
      Property Value

      string

      Remarks

      We recommend generalPurpose performance mode for all file systems. File systems using the maxIO performance mode can scale to higher levels of aggregate throughput and operations per second with a tradeoff of slightly higher latencies for most file operations. The performance mode can't be changed after the file system has been created. The maxIO mode is not supported on One Zone file systems.

      Due to the higher per-operation latencies with Max I/O, we recommend using General Purpose performance mode for all file systems.
      

      Default is generalPurpose .

      See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-performancemode

      ProvisionedThroughputInMibps

      The throughput, measured in mebibytes per second (MiBps), that you want to provision for a file system that you're creating.

      double? ProvisionedThroughputInMibps { get; }
      Property Value

      double?

      Remarks

      Required if ThroughputMode is set to provisioned . Valid values are 1-3414 MiBps, with the upper limit depending on Region. To increase this limit, contact Support . For more information, see Amazon EFS quotas that you can increase in the Amazon EFS User Guide .

      See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-provisionedthroughputinmibps

      ReplicationConfiguration

      Describes the replication configuration for a specific file system.

      object? ReplicationConfiguration { get; }
      Property Value

      object

      Remarks

      See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-replicationconfiguration

      Type union: either IResolvable or CfnFileSystem.IReplicationConfigurationProperty

      ThroughputMode

      Specifies the throughput mode for the file system.

      string? ThroughputMode { get; }
      Property Value

      string

      Remarks

      The mode can be bursting , provisioned , or elastic . If you set ThroughputMode to provisioned , you must also set a value for ProvisionedThroughputInMibps . After you create the file system, you can decrease your file system's Provisioned throughput or change between the throughput modes, with certain time restrictions. For more information, see Specifying throughput with provisioned mode in the Amazon EFS User Guide .

      Default is bursting .

      See: http://docs.aws.amazon.com/AWSCloudFormation/latest/UserGuide/aws-resource-efs-filesystem.html#cfn-efs-filesystem-throughputmode

      Back to top Generated by DocFX